package comparator.constraints;

import comparator.GenericComparator;
import java.util.List;


import solution.Solution;

public abstract class ConstrainedGenericComparator extends GenericComparator
{
    protected boolean prepared = false;
    protected int feasibleSolutionCount;
   
    public abstract void prepare (List<Solution> population);
    
    public void unprepare()
    {
	prepared = false;
    }
    
    public boolean isPrepared()
    {
	return prepared;
    }
    
    protected int getFeasibleSolutionCount()
    {
	return feasibleSolutionCount;
    }

}
