package comparator.multiObjective;

public class MOSolutionRanking
{
   
    private int[] objectiveRankings;
    
    
    public MOSolutionRanking(int obj)
    {
	objectiveRankings = new int[obj];
	
    }
    
    public int getRankingForObjective(int obj)
    {
	return objectiveRankings[obj];
    }
    
    public void setRankingForObjective(int obj, int value)
    {
	objectiveRankings[obj] = value;
    }
    
    public double getAverageRanking()
    {
	double d = 0;
	for (int i = 0; i < objectiveRankings.length; i++)
	{
	    d += objectiveRankings[i];
	}
	d /= objectiveRankings.length;
	return d;
    }

    

}
