package problem.QAP;

import java.util.Properties;
import java.util.Scanner;
import problem.Problem;

public class ConstrainedQAPProblem extends Problem
{
    private int n;

    private int k; //the length of the ideal repetition
    private int c; // the length of the no-go-zone
    private int[][] distanceMatrix;
    // int[][] matrixB;
    private static int maxConstraintViolation;
    private int offset;
    private int options;

    public void ConstrainedQAPProblem(){
        
    }
    public static void initialiseMaxConstraintViolation(int n, int c, int o)
    {
        maxConstraintViolation = (n / (c/2+o))* (c/2);
        System.out.println("Max violation "+maxConstraintViolation);

    }
    public int[][]  getDistanceMatrix(){
        return distanceMatrix;
    }
    public int getMaxConstraintViolation()
    {
        return maxConstraintViolation;
    }
    public int getC()
    {
	return c;
    }

    public int getOffset()
    {
	return offset;
    }

    public ConstrainedQAPProblem(int n, int numberOfItems)
    {
	this.n = n;
	distanceMatrix = new int[n][n];
	//matrixB = new int[n][n];
	options = numberOfItems;
	FEcounter = 0;

    }

    @Override
    public int getOptions()
    {
	return options;
    }

    @Override
    public void initialise(Properties props)
    {
        super.initialise(props);
	c =Integer.parseInt(props.getProperty("c"));
	k = Integer.parseInt(props.getProperty("k"));
	offset = Integer.parseInt(props.getProperty("o"));
	numberOfFE = Integer.parseInt(props.getProperty("FE"));
    }

    public int getK(){
        return k;
    }
    public void fillMatrix(Scanner sc)
    {

	for (int i = 0; i< distanceMatrix.length; i++)
	    for(int j = 0; j < distanceMatrix[i].length; j++)
		distanceMatrix[i][j] = sc.nextInt();
    }

    /* implementation for contiguous optima - all assignments considered in numerical order, i.e.
     * same assignments considered when they are one behind the other
     * 
     * public int evaluateSolution(Solution sol)
    {
	int result = 0;
	boolean valid = true;
	int x = sol.getAssignmentForPosition(0);
	int y;
	int consecutiveNumbersCounter = 1;
	for (int i = 1; i < n; i++)
	{
	    y = sol.getAssignmentForPosition(i);
	    if (x == y)
	    	consecutiveNumbersCounter++;
	    else
	    {
		if (consecutiveNumbersCounter > 1 && consecutiveNumbersCounter <= c)
		    valid = false;
		consecutiveNumbersCounter = 1;
	    }

	    result += matrixA[i-1][i] * Math.pow(matrixB[x][y], consecutiveNumbersCounter/c) ;

	    x = y;
	}
	sol.setValid(valid);
	return result;
    }*/

   
}
