package comparator.multiObjective;

import java.util.Comparator;


public class ObjectiveComparator implements Comparator<int[]>
{
    private int objectiveToCompare = 0;

    @Override
    public int compare(int[] arg0, int[] arg1)
    {
	if ( arg0[objectiveToCompare] > arg1[objectiveToCompare])
	    return 1;
	else if(arg0[objectiveToCompare] < arg1[objectiveToCompare])
	    return -1;
	return 0;
    }

    
    

    
    public void prepare(int objective)
    {
	objectiveToCompare = objective;

    }
    //this comparator is always ready
    public boolean isPrepared()
    {
	return true;
    }

}
