package comparator.singleObjective;
import comparator.GenericComparator;

import solution.Solution;

/**
 *
 * @author Alda
 */
public class FitnessComparator extends GenericComparator{
    public void setMinMax(double min, double max )
    {}

 
    @Override
    public int compare(Solution sol1, Solution sol2)
    {
	sol1.setPenaltyFitness(sol1.getCurrentFitness());
	sol2.setPenaltyFitness(sol2.getCurrentFitness());
        if(optimisation.equals("maximisation")){
            if (sol1.getCurrentFitness() > sol2.getCurrentFitness())
                return -1;
            else if(sol1.getCurrentFitness() < sol2.getCurrentFitness())
                return 1;
        }else{
            if (sol1.getCurrentFitness() > sol2.getCurrentFitness())
                return 1;
            else if(sol1.getCurrentFitness() < sol2.getCurrentFitness())
                return -1;
        }
        return 0;
    }
}
