/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package learning.benchmarks;


public class BanditRestart extends BanditAlone {
	boolean change;
	AdaptivePH adaptPH;

	public BanditRestart(int N_operators, boolean User, double v_Scaling, double v_Gamma, int _normalize)
	{
		super(N_operators, User, v_Scaling, _normalize, 1);
		adaptPH = new AdaptivePH(n_operators, v_Gamma);
	change=false;
}

	@Override
public double applyReward(int op){
	change=false;
	double rewardPH = getReward(op);

	change = adaptPH.CheckPH(op, rewardPH);
	if(change) reset();

	return rewardPH;
}

	@Override
public void reset(){
	adaptPH.Restart();
}


public boolean getRestart(){
	return change;
}


}
