package learning.parameters;

public class ObjectParameter extends Parameter{

	private Object[] parameterValues;

	public ObjectParameter(Object sName, Object paramValues[]){
            super(sName);
		parameterValues=paramValues;

	}
	public void setParameterValuess(Object[] paramValues){
		parameterValues=paramValues;
	}
	public ObjectParameter(Parameter parent){
            super(parent);
            parameterValues = ((ObjectParameter)parent).getParameterValues();
            name= parent.getName();
	}
	public Object[] getParameterValues(){
		return parameterValues;
	}
	
        @Override
        public void initialiseBins(){
           super.initialiseBins();
           int index=0;
           for(Object pValue: parameterValues){
                ObjectBin bin = new ObjectBin(pValue, index++);
                listBins.add(bin);
            }
        }

}