package utility;
import java.io.*;

public class Logger {

    private static  Logger logger =null;
    private static PrintWriter[] logWriter = new PrintWriter[3];
    private static String batchFileName = "Batch.csv";
    private static String resultFileName = "Results.csv";
    public static final int BATCHFILE = 0;
    public static final int RESULTFILE = 1;

    public Logger(String filename){
        batchFileName= "Results/"+filename+"Batch.csv";
        resultFileName = "Results/"+filename+"Results.csv";
	try {
	    logWriter[BATCHFILE] = new PrintWriter(new FileWriter(batchFileName));
	    logWriter[RESULTFILE] = new PrintWriter(new FileWriter(resultFileName));
	} catch (IOException e) {
	    System.out.println("LOG:Error making log files.");
	}
    }

    public void closeLogs(){
	for (int i = 0; i < logWriter.length; i++){
	    if (logWriter[i]!= null)
		logWriter[i].close();
	}
    }

    public static Logger getLogger(){
	return logger;
    }

    public void logLine(int file, String line){
	logWriter[file].println(line);
	logWriter[file].flush();

    }
}
