package utility;

import java.util.Random;

import solution.Solution;

public class Utils
{
    public static Random random = null;

    public static double getNormalisedHammingDistance(Solution sol1, Solution sol2, int length)
    {
	double d = 0;
	for (int i = 0; i < length; i++)
	{
	    if (sol1.getAssignmentForPosition(i) != sol2.getAssignmentForPosition(i))
		d += 1;
	}

	d /= length;
	return d;
    }

    public static double getStandardDeviation(double[] array, double average)
    {
	double result = 0;

	for (int i = 0; i < array.length; i++)
	{
	    result += Math.pow((array[i]-average), 2);
	}
	result /= array.length;
	result = Math.sqrt(result);
	return result;
    }

    public static double getRandomDoubleforInterval(double from, double to)
    {
	double j;
	j = from + (int)( (to-from)*Utils.random.nextFloat() );
	return j;

    }

}
